"use strict";
var countries_1 = require("./data/countries");
// * listCities function recive code (string of 2 char length) and options object(optional)
// * return array of cities names
var listCities = function (code, options) {
    try {
        if (!code || typeof code !== 'string')
            return Promise.reject('code value accept string only ');
        // * get data from the related module
        var data = require("../data/cities/" + code.toUpperCase() + ".js").data;
        // * map the data and return the city name
        var list_1 = data.map(function (item) { return item.name; });
        // * return sub list
        return list_1.splice((options === null || options === void 0 ? void 0 : options.skip) || 0, (options === null || options === void 0 ? void 0 : options.limit) || 6000);
    }
    catch (err) {
        return err;
    }
};
/* -------------------------------------------------------------------------- */
var listCountries = function (options) {
    if (options === void 0) { options = 'name'; }
    var keys = ['flag', 'phone', 'name', 'code'];
    // * convert options string to array
    var optionsArr = options.trim().split(' ');
    // * return error if one of the optionsArr is not defiend
    if (!optionsArr.every(function (item) { return keys.includes(item); }))
        return Promise.reject('options string only accept flag,phone,name and code');
    // * return array of strings if only one option is sent
    if (optionsArr.length === 1)
        return countries_1.list.map(function (item) { return item[optionsArr[0]]; });
    // * return array of objects if more than one options is sent
    return countries_1.list.map(function (item) {
        var obj = {};
        optionsArr.map(function (opt) { return (obj[opt] = item[opt]); });
        return obj;
    });
};
var searchCountries = function (text, options) {
    if (options === void 0) { options = 'name'; }
    try {
        var keys_1 = ['flag', 'phone', 'name', 'code'];
        // * convert options string to array
        var optionsArr_1 = options.trim().split(' ');
        // * return error if one of the options is not defiend
        if (!optionsArr_1.every(function (item) { return keys_1.includes(item); }))
            return Promise.reject('options string only accept flag,phone,name and code');
        // * prepare the regexp
        var comparative = new RegExp(text.toUpperCase());
        var data = countries_1.list
            .filter(function (item) { return comparative.test(item.name.toUpperCase()); })
            .map(function (item) {
            var obj = {};
            var arr = [];
            optionsArr_1.map(function (opt) { return (optionsArr_1.length === 1 ? arr.push(item[opt]) : (obj[opt] = item[opt])); });
            return arr.length ? arr[0] : obj;
        });
        return data;
    }
    catch (err) {
        return err;
    }
};
module.exports = { listCities: listCities, listCountries: listCountries, searchCountries: searchCountries };
